bwa2018djangoproject/urls.py
from django.contrib import admin
from django.urls import path, include
from . import views


urlpatterns = [
    path('admin/', admin.site.urls),
    path('', views.index, name="landing_page"),
    path('err404', views.not_found, name="error_404"),
    path('err500', views.error_500, name="error_500"),
    path('members/', include('members.urls')),
    path('discussions/', include('discussions.urls')),
]

members/urls.py
from django.urls import path
from members.views import SignUp, SignIn, profile, Friends, FriendRequestHandler, friends_view, logout, StatusHandler, \
    CommentHandler, UserInformation, delete_user

app_name = 'members'

urlpatterns = [
    path('login/', SignIn.as_view(), name='login'),
    path('signup/', SignUp.as_view(), name='signup'),
    path('info/<username>', UserInformation.as_view(), name='information'),
    path('profile/<username>', profile, name='profile'),
    path('friendsview/<username>', friends_view, name='friends_view'),
    path('friends/<username>', Friends.as_view(), name='friends'),
    path('friendrequest/<username>', FriendRequestHandler.as_view(), name='friend_requests'),
    path('friends/<username>', Friends.as_view(), name='friends'),
    path('logout', logout, name='logout'),
    path('status/', StatusHandler.as_view(), name='status'),
    path('comment/', CommentHandler.as_view(), name='comment'),
    path('delete', delete_user, name='delete')
]

members/forms.py
from .models import Member
from django import forms


class SignUpForm(forms.ModelForm):
    first_name = forms.CharField(max_length=50, widget=forms.TextInput(attrs={'class': 'form-control'}))
    last_name = forms.CharField(max_length=50, widget=forms.TextInput(attrs={'class': 'form-control'}))
    username = forms.CharField(max_length=50, widget=forms.TextInput(attrs={'class': 'form-control'}))
    password = forms.CharField(max_length=50, widget=forms.PasswordInput(attrs={'class': 'form-control'}))
    email = forms.CharField(max_length=50, widget=forms.EmailInput(attrs={'class': 'form-control'}))
    phone_number = forms.CharField(max_length=20, widget=forms.NumberInput(attrs={'class': 'form-control'}))
    address = forms.CharField(max_length=50, widget=forms.TextInput(attrs={'class': 'form-control'}))

    class Meta:
        model = Member
        fields = ['first_name', 'last_name', 'username', 'password', 'email', 'phone_number', 'address']


class UserInformationForm(forms.ModelForm):
    first_name = forms.CharField(max_length=50, widget=forms.TextInput(attrs={'class': 'form-control'}))
    last_name = forms.CharField(max_length=50, widget=forms.TextInput(attrs={'class': 'form-control'}))
    phone_number = forms.CharField(max_length=20, widget=forms.NumberInput(attrs={'class': 'form-control'}))
    address = forms.CharField(max_length=50, widget=forms.TextInput(attrs={'class': 'form-control'}))

    class Meta:
        model = Member
        fields = ['first_name', 'last_name', 'phone_number', 'address']



class SignInForm(forms.ModelForm):
    username = forms.CharField(max_length=50, widget=forms.TextInput(attrs={'class': 'form-control'}))
    password = forms.CharField(max_length=50, widget=forms.PasswordInput(attrs={'class': 'form-control'}))

    class Meta:
        model = Member
        fields = ['username', 'password']


class StatusForm(forms.Form):
    status = forms.CharField(widget=forms.Textarea)

members/views.py
from django.http import HttpResponse, Http404, HttpResponseRedirect, JsonResponse
from django.shortcuts import render, redirect
from django.urls import reverse
from django.views import generic
from django.views.generic.edit import CreateView, UpdateView, DeleteView
from django.views.generic import View
from .models import Member, FriendRequest, Status, Comment
from .forms import SignUpForm, SignInForm, UserInformationForm


def profile(request, username):
    try:
        member = Member.find_member_by_username(username)
        if member is not None:
            owner = is_user_owner(request, username)
            show_private = request.user.is_authenticated
            return render(request, "members/profile.html",
                          {'member': member, 'owner': owner, 'show_private': show_private, 'is_profile': True})
        else:
            return HttpResponseRedirect(reverse('error_404'))
    except Member.DoesNotExist:
        return HttpResponseRedirect(reverse('error_404'))


def delete_user(request):
    username = request.user.username
    Member.logout(request)
    Member.delete_member(username)
    return HttpResponseRedirect(reverse('members:login'))


def is_user_owner(request, username):
    return request.user.username == username


def friends_view(request, username):
    owner = is_user_owner(request, username)
    return render(request, "members/friends.html")


def logout(request):
    Member.logout(request)
    return HttpResponseRedirect(reverse('members:login'))


class Friends(View):

    def get(self, request, username):
        owner = is_user_owner(request, username)
        friends_list = {'owner': owner, 'friends': Member.get_member_friends_by_username_json(username)}
        return JsonResponse(friends_list)

    def post(self, request, username):
        owner = is_user_owner(request, username)
        action = request.POST.get('action', '')
        if action == 'view_profile':
            print('-----------------------------------------')
            return HttpResponseRedirect(reverse('members:profile', args=(request.POST.get('friend_username', ''),)))
        if action == 'delete_friend':
            Member.remove_friend(request.POST.get('username', ''), request.POST.get('friend_username', ''))
            result = {'message': 'ok'}
            return JsonResponse(result)


class FriendRequestHandler(View):
    def get(self, request, username):
        owner = is_user_owner(request, username)
        friend_request_list = {'request_list': FriendRequest.get_friend_requests_json(username)}
        return JsonResponse(friend_request_list)

    def post(self, request, username):
        action = request.POST.get('action', '')
        owner = is_user_owner(request, username)
        if action == 'delete':
            request_id = request.POST.get('request-id', '')
            FriendRequest.delete_friend_request(request_id)
            result = {'message': 'ok'}
            return JsonResponse(result)

        if action == 'create':
            sender_username = request.POST.get('sender', '')
            receiver_username = request.POST.get('receiver', '')
            FriendRequest.create_friend_request(sender_username=sender_username, receiver_username=receiver_username)
            result = {'message': 'ok'}
            return JsonResponse(result)

        if action == 'accept':
            request_id = request.POST.get('request-id', '')
            FriendRequest.accept_friend_request(request_id)
            result = {'message': 'ok'}
            return JsonResponse(result)

        if action == 'reject':
            request_id = request.POST.get('request-id', '')
            FriendRequest.reject_friend_request(request_id)
            result = {'message': 'ok'}
            return JsonResponse(result)

        if action == 'list-closed':
            sender_username = request.POST.get('sender', '')
            result = FriendRequest.get_closed_friend_requests_json(sender_username)
            result = {'data': result}
            return JsonResponse(result)


class SignUp(View):
    sign_up_form = SignUpForm
    template_name = 'members/registration_form.html'

    def get(self, request):
        form = self.sign_up_form(None)
        if request.user.is_authenticated:
            member = Member.find_member_by_username(request.user.username)
            form = self.sign_up_form(initial={'first_name': member.user.first_name, 'last_name': member.user.last_name,
                                              'username': member.user.username,
                                              'email': member.user.email, 'phone_number': member.phone_number,
                                              'address': member.address})

        return render(request, self.template_name, {'form': form})

    def post(self, request):
        form = self.sign_up_form(request.POST)
        if form.is_valid():
            user = form.save(commit=False)

            first_name = form.cleaned_data['first_name']
            last_name = form.cleaned_data['last_name']
            username = form.cleaned_data['username']
            password = form.cleaned_data['password']
            email = form.cleaned_data['email']
            phone_number = form.cleaned_data['phone_number']
            address = form.cleaned_data['address']

            member = Member()
            member.create_member(first_name=first_name, last_name=last_name, username=username, password=password,
                                 email=email, phone_number=phone_number, address=address)

            if member is not None:
                user_session = Member.login(username, password, request)

                if user_session is not None:
                    if user_session.is_active:
                        return HttpResponseRedirect(reverse('members:profile', args=(username,)))
                    else:
                        return HttpResponse("Your account is disabled.")
                else:
                    return HttpResponseRedirect(reverse('error_500'))
            else:
                return HttpResponseRedirect(reverse('error_500'))


class UserInformation(View):
    information_form = UserInformationForm
    template_name = 'members/member_info_form.html'

    def get(self, request, username):
        form = self.information_form(None)
        if request.user.is_authenticated:
            member = Member.find_member_by_username(request.user.username)
            form = self.information_form(
                initial={'first_name': member.user.first_name, 'last_name': member.user.last_name,
                         'phone_number': member.phone_number,
                         'address': member.address})

        return render(request, self.template_name, {'form': form})

    def post(self, request, username):
        form = self.information_form(request.POST)
        if form.is_valid():
            user = form.save(commit=False)

            first_name = form.cleaned_data['first_name']
            last_name = form.cleaned_data['last_name']
            phone_number = form.cleaned_data['phone_number']
            address = form.cleaned_data['address']

            if Member.update_information(username=username, first_name=first_name, last_name=last_name,
                                         phone_number=phone_number,
                                         address=address):
                return HttpResponseRedirect(reverse('members:profile', args=(username,)))
            else:
                return HttpResponseRedirect(reverse('error_500'))


class SignIn(View):
    sign_in_form = SignInForm
    template_name = 'members/login_form.html'

    def get(self, request):
        if request.user.is_authenticated:
            username = request.user.username
            return HttpResponseRedirect(reverse('members:profile', args=(username,)))
        else:
            form = self.sign_in_form(None)
            return render(request, self.template_name, {'form': form})

    def post(self, request):
        username = request.POST.get('username')
        password = request.POST.get('password')
        user_session = Member.login(username, password, request)

        if user_session is not None:
            if user_session.is_active:
                return HttpResponseRedirect(reverse('members:profile', args=(username,)))
            else:
                return HttpResponse("Your account is disabled.")
        else:
            form = self.sign_in_form(None)
            return render(request, self.template_name, {'form': form, 'error': 'Wrong username or password'})


class StatusHandler(View):
    def get(self, request):
        current_user = request.user.username
        status_list = Status.get_member_status_list_json(request.GET.get('username', ''), current_username=current_user)
        result = {'status_list': status_list}
        return JsonResponse(result)

    def post(self, request):
        action = request.POST.get('action')
        if action == 'create':
            content = request.POST.get('content', '')
            Status.create_status(content=content, owner_username=request.user.username)
            result = {'message': 'ok'}
            return JsonResponse(result)
        if action == 'update':
            status_id = request.POST.get('id', '')
            content = request.POST.get('content', '')
            Status.update_status(status_id=status_id, content=content)
            result = {'message': 'ok'}
            return JsonResponse(result)
        if action == 'delete':
            status_id = request.POST.get('id', '')
            Status.delete_status(status_id=status_id)
            result = {'message': 'ok'}
            return JsonResponse(result)
        return HttpResponseRedirect(reverse('error_404'))


class CommentHandler(View):

    def post(self, request):
        action = request.POST.get('action')
        if action == 'create':

members/templates/members/base.html
{% extends "base.html" %}

members/templates/members/friends.html
{% extends 'members/base.html' %}

{% block title %}
    Friends
{% endblock %}

{% block content %}
    <div class="row ml-2 mr-2">
        <div class="col-lg-4">
            <div class="card">
                <div class="card-title text-center">New Friend</div>
                <div class="card-body">
                    <div class="form-group">
                        <label for="tb-new-friend-username">Username</label>
                        <input id="tb-new-friend-username" class="form-control" type="text">
                    </div>
                    <button id="btn-send-friend-request" type="submit" class="btn btn-primary">Send Request</button>

                </div>

            </div>
            <div class="border mt-2">
                <div id="request-list" class="card-title text-center">Friend Request</div>
                <div id="received-request"></div>
                <div id="sent-request"></div>

            </div>

        </div>
        <div id="friend-list" class="col-lg-8 friend-list">
        </div>
    </div>


    {% csrf_token %}
    <script>

        const getFriendList = () => {
            $('#friend-list').empty();
            $.ajax("{% url "members:friends" request.user.username %}").done(data => {
                console.log(data);
                if (data.friends) {
                    data.friends.forEach(friend => {
                        let card = document.createElement('div');
                        $(card).addClass('card mt-2 mb-2 mr-2 ml-2 float-left friend-card text-center');

                        let img = document.createElement('img');
                        $(img).addClass('card-img-top friend-card-img');
                        {% load static %}
                        $(img).attr('src', '{% static 'images/user-img.png' %}');


                        let cardbody = document.createElement('div');
                        $(cardbody).addClass('card-bod');


                        let cardTitle = document.createElement('h5');
                        $(cardTitle).addClass('card-title');
                        $(cardTitle).text(`${friend.username}(${friend.first_name} ${friend.last_name})`);
                        cardTitle.dataset.username = friend.username;
                        $(cardTitle).on('click', (event) => {
                            window.location.pathname = creatreUserProfileUrl(event.target.dataset.username) ;
                        });

                        let cardText = document.createElement('div');
                        $(cardText).addClass('card-text');
                        $(cardText).text(friend.status);

                        let actions = document.createElement('div');
                        $(actions).addClass('action-container');

                        let message = document.createElement('button');
                        $(message).addClass('btn btn-primary');
                        $(message).text('Message');

                        let delete_friend = document.createElement("div");
                        $(delete_friend).addClass('fas fa-trash-alt delete-friend');
                        delete_friend.dataset.username = friend.username;
                        {#=============================================================================================================#}
                        let delete_container = document.createElement('div');
                        $(delete_container).addClass('delete-container');
                        delete_container.dataset.username = friend.username;
                        $(delete_container).append(delete_friend);
                        $(delete_container).on('click', (event) => {
                            let friend_username = '';
                            if (event.target.tagName === 'path') {
                                friend_username = event.target.parentElement.parentElement.dataset.username;
                            }
                            if (event.target.tagName === 'svg') {
                                friend_username = event.target.parentElement.dataset.username;
                            }
                            if (event.target.tagName === 'div') {
                                friend_username = event.target.dataset.username;
                            }
                            if (confirm("Are You Sure?")) {
                                let csrftoken = jQuery("[name=csrfmiddlewaretoken]").val();
                                $.ajax({
                                    method: 'POST',
                                    headers: {"X-CSRFToken": csrftoken},
                                    url: '{% url "members:friends" request.user.username %}',
                                    data: {
                                        action: 'delete_friend',
                                        username: '{{ request.user.username }}',
                                        friend_username: friend_username
                                    },
                                    success: (data, textStatus) => {
                                        getFriendList();
                                    }
                                })
                            }

                        });

                        {#$(actions).append(message);#}
                        $(actions).append(delete_container);


                        $(cardbody).append(cardTitle);
                        $(cardbody).append(cardText);
                        $(cardbody).append(actions);

                        $(card).append(img);
                        $(card).append(cardbody);
                        $('#friend-list').append(card);
                    });
                }
            });
        };

        const getFriendRequestList = () => {
            $('#sent-request').empty();
            $('#received-request').empty();
            $.ajax("{% url "members:friend_requests" request.user.username %}").done(data => {
                console.log(data);
                if (data.request_list) {
                    data.request_list.forEach(request => {

                        if (request.status !== 'Open') {
                            return;
                        }

                        let card = document.createElement('div');
                        $(card).addClass('border mt-2 mb-2 mr-2 ml-2 friend-request-card text-center ');

                        let img = document.createElement('img');
                        $(img).addClass(' friend-request-card-img');
                        {% load static %}
                        $(img).attr('src', '{% static 'images/user-img.png' %}');


                        let content = document.createElement('div');
                        $(content).addClass('content');


                        let cardText = document.createElement('div');
                        $(cardText).addClass('card-text ml-1');


                        $(content).append(cardText);
                        $(card).append(img);
                        $(card).append(content);

                        //sent request
                        if (request.sender && request.sender === '{{ request.user.username }}') {
                            $(cardText).html(`<p>${request.receiver} <span class="timestamp">(${formateDate(request.created_time)})</span><p>`);

                            let btn_delete = document.createElement('button');
                            $(btn_delete).addClass('btn btn-danger float-right');
                            $(btn_delete).text('DELETE');
                            btn_delete.dataset.id = request.id;
                            $(btn_delete).on('click', (event) => {
                                let csrftoken = jQuery("[name=csrfmiddlewaretoken]").val();
                                $.ajax({
                                    method: "POST",
                                    url: '{% url 'members:friend_requests' request.user.username %}',
                                    headers: {"X-CSRFToken": csrftoken},
                                    data: {
                                        'action': 'delete',
                                        'request-id': event.target.dataset.id
                                    },
                                    success: (data, textStatus) => {
                                        console.log(textStatus, ' ', data);
                                        if (data.message && data.message === 'ok') {
                                            getFriendRequestList();
                                        }
                                    }
                                });
                            });

                            let action_container = document.createElement('div');
                            $(action_container).addClass('action-container');
                            $(action_container).append(btn_delete);

                            $(card).append(action_container);


                            $('#sent-request').append(card);
                        }

                        // received request
                        if (request.receiver && request.receiver === '{{ request.user.username }}') {

                            $(cardText).html(`<p>${request.sender} <span class="timestamp">(${formateDate(request.created_time)})</span><p>`);

                            let btn_reject = document.createElement('button');
                            $(btn_reject).addClass('btn btn-danger ml-1');
                            $(btn_reject).text('REJECT');
                            btn_reject.dataset.id = request.id;
                            $(btn_reject).on('click', (event) => {
                                let csrftoken = jQuery("[name=csrfmiddlewaretoken]").val();
                                $.ajax({
                                    method: "POST",
                                    url: '{% url 'members:friend_requests' request.user.username %}',
                                    headers: {"X-CSRFToken": csrftoken},
                                    data: {
                                        'action': 'reject',
                                        'request-id': event.target.dataset.id
                                    },
                                    success: (data, textStatus) => {
                                        console.log(textStatus, ' ', data);
                                        if (data.message && data.message === 'ok') {
                                            getFriendRequestList();
                                            getFriendList();
                                        }
                                    }
                                });
                            });


                            let btn_accept = document.createElement('button');
                            $(btn_accept).addClass('btn btn-primary ');
                            $(btn_accept).text('ACCEPT');
                            btn_accept.dataset.id = request.id;
                            $(btn_accept).on('click', (event) => {
                                let csrftoken = jQuery("[name=csrfmiddlewaretoken]").val();
                                $.ajax({
                                    method: "POST",
                                    url: '{% url 'members:friend_requests' request.user.username %}',
                                    headers: {"X-CSRFToken": csrftoken},
                                    data: {
                                        'action': 'accept',
                                        'request-id': event.target.dataset.id
                                    },
                                    success: (data, textStatus) => {
                                        console.log(textStatus, ' ', data);
                                        if (data.message && data.message === 'ok') {
                                            getFriendRequestList();
                                            getFriendList();
                                        }
                                    }
                                });
                            });


                            {#action-container#}
                            let action_container = document.createElement('div');
                            $(action_container).addClass('action-container');
                            $(action_container).append(btn_accept);
                            $(action_container).append(btn_reject);

                            $(card).append(action_container);

                            $('#received-request').append(card);
                        }
                    })
                }

            });
        };


        $(document).ready(() => {

            getFriendList();

            getFriendRequestList();


            $('#btn-send-friend-request').on('click', () => {
                let csrftoken = jQuery("[name=csrfmiddlewaretoken]").val();
                $.ajax({
                    method: "POST",
                    url: "{% url "members:friend_requests" request.user.username %}",
                    headers: {"X-CSRFToken": csrftoken},
                    data: {
                        action: 'create',
                        sender: '{{ request.user.username }}',
                        receiver: $('#tb-new-friend-username').val()
                    },
                    success: (data, textStatus) => {
                        console.log(textStatus, ' ', data);
                        if (data.message && data.message === 'ok') {
                            getFriendRequestList();
                        }
                    }
                });


            });
        });
    </script>

{% endblock %}

members/templates/members/index.html
{% block content %}
    {{ message }}
{% endblock %}

members/templates/members/login_form.html
{% extends 'members/base.html' %}

{% block title %}
    Login
{% endblock %}

{% block content %}
    <div class="container-fluid">
        <div class="row align-items-center justify-content-center">
            <div class="col-lg-6 col-md-10 col-sm-12">
                {% if error %}
                    <div class="alert alert-danger" role="alert">
                                {{ error }}
                    </div>
                {% endif %}
                <div class="card">
                    <div class="card-body">
                        <form action="" method="POST" role="form">
                            {% csrf_token %}
                            {% for field in form %}
                                <div class="fieldWrapper form-group" aria-required={% if field.field.required %}"true"
                                {% else %}"false"
                                {% endif %}>
                                {{ field.label_tag }}{% if field.field.required %}<span class="required">*</span>
                                {% endif %}
                                {{ field }}
                                {% if field.help_text %}
                                    <p class="help">{{ field.help_text|safe }}</p>
                                {% endif %}
                                </div>
                            {% endfor %}
                    <input id="btnLogin" type="submit" class="btn btn-primary mb-2" value="Login"/>
                    <button type="button" id="btnSignup" class="btn btn-secondary mb-2">New User</button>

                </div>
            </div>

            </form>
        </div>
    </div>

    <script type="application/javascript">
        $('#btnSignup').on('click', () => {
            window.location = '{% url 'members:signup' %}';
        });
    </script>

{% endblock %}

members/templates/members/status_form.html
    <div class="card-body">
        <form action="" method="POST" >
            {%csrf_token%}
            <div class="form-group">
                <div><label class="inline_label">What's in your mind?</label></div>
                <div>{{ fields }}</div>
                <div><button type="submit" class="btn btn-primary mb-2">Submit</button></div>
            </div>
        </form>
    </div>

members/templates/members/user_info.html
<div class="user-info border rounded p-3">
    <div><strong>Name: </strong>{{ member.user.first_name }} {{ member.user.last_name }}</div>
    <div><strong>Email address: </strong>{{ member.user.email }}</div>
    {% if show_private %}
        <div><strong>Phone: </strong>{{ member.phone_number }}</div>
        <div><strong>Address: </strong>{{ member.address }}</div>
    {% endif %}
    {% if request.user.is_authenticated and request.user.username == member.user.username %}
        <div class="user-info-actions">
            <a class="btn-edit-user-info" href="{% url "members:information" request.user.username %}"><i
                    class="fas fa-edit"></i></a>
        <div id="btn-delete-user" class="btn-delete-user" href="{% url "members:information" request.user.username %}"><i class="fas fa-trash-alt"></i></div>
        </div>

        <script>
            $(document).ready(()=>{
                $('#btn-delete-user').on('click', ()=>{
                    if (confirm("Are You Sure?")) {
                        window.location = '{% url "members:delete" %}';
                    }
                });
            })
        </script>

    {% endif %}
</div>